 // Прошивка Большая Медведица.   Одновременная работа шаговыми двигателями с плавным ускорением и замедлением
//Наведение и слежение.Работает  база  каталога Месье.Настройка координат места наблюдения 

#include <MicroView.h>  // библиотека для работы с платформой MicroView
#include <Wire.h>       // библиотека для работы I²C 
#include "TroykaRTC.h"  // библиотека для работы с часами реального времени
    // EEPROM — энергонезависимая память
#include <EEPROM.h>  // библиотека для записи и считывания информации с EEPROM
   // библиотеки взял с сайта Амперка и поместил в папку libraries в программе Arduini IDE.
   
RTC clock;          // создаём объект для работы с часами реального времени
    // драйверы Troyka-Stepper для шаговиков подключены к следующим пинам:
  const byte stepPinx = 3;        //  сделать шаг
  const byte directionPinx = 5;   //  направление
  const byte enablePinx = 6;      //  питание
  const byte stepPiny = 0;       //  сделать шаг
  const byte directionPiny = 1;  //  направление
  const byte enablePiny = 2;     //  питание
      // задаём переменные:
  float voltage;  //для хранения сигнала с кнопок
  long shagov = 0;   // количество шагов
  int p;  //питание обмоток двигателей
  //long times = 0;     // задержка шага в микросекундах
  long q = 0;        // сколько шагов сделано ось RA
  long w = 0;        // сколько шагов сделано ось DEC
  int qs=0;         //азимут секунды на дисплей
  int qm=0;         // азимут минуты на дисплей
  float qflm;       // азимут минуты в десятичной мере
  int qg=0;         // азимут градусы на дисплей
  int ws=0;         // высота секунды на дисплей
  int wm=0;         // высота минуты на диспл ALTm
  float wflm=0;     // высота минуты в десятичной мере
  int wg=0;         // высота градусы на диспл ALTg
  int misye=0;     //номер обьекта в каталоге Месье
  byte zh =0;    //зв часы на диспл   long
  float zm1=0;
  byte zm =0;      //зв мин на диспл  long
  float zs1=0;
  byte zs =0;     // звёздные сек на диспл   long
  float h = 18.0;         // координаты обьекта RA, часы  float
  float m = 37.0;         // координаты обьекта RA, минуты float
  float s = 37.0;         // координаты обьекта RA, секунды float
  float decg = 38.0;       // координаты небесного объекта DEC,градусы,по умолчанию 89 float
  float decm = 48.0;        // координаты небесного объекта DEC, минуты float
  float decs = 10.0;       // координаты небесного объекта DEC, секунды  float
char hc;  //хранит данные каталога  RA час
char mc;//хранит данные каталога    RA мин
char sc;//хранит данные каталога    RA сек
char decgc;//хранит данные каталога  DEC градус
char decmc;//хранит данные каталога  DEC мин
char decsc;//хранит данные каталога  DEC сек
  float ras=0;   // прямое восхождение  общее в секундах
  int hh=0;           //часы RA для вывода на дисплей
  int mm=0;           //минуты RA на дисплей
  int decgg=0;        // градусы DEC на дисплей
  int decmm=0;        // минуты DEC на дисплей
  float latg=59.0;//широта целых градусов
  float latm=55.0;//широта целых минут
  float lats=48.0;//долгота целых градусов
  byte latg1;
  byte latm1;
  byte lats1;
  float q1 = 0.0;       
  float w1 = 0.0; 
  long Chas=0;     // местный час
  long Min=0;      // местная минута
  long SEC =0;    //  местная секунда
  int mes=0;     //текущий месяц
  long den=0; // сколько дней прошло с начала текущего года
  int vis=0;     //високосный добавочный день
  int god=0;  //год
  long dney=0; // сколько дней прошло начиная с 2017 года
  long ciclo=0;  // какое сегодня число
  float kden=0; //общ количество секунд накопившихся с начала 2017 года
  float lst = 0;  //звездное время в градусной мере
  float lsts=0;  //звездное время общ в сеундной мере
  float lsth=0;  //звездное время в часовой мере
  float kvrem=0;     //коэффициент для зв времени
  float lat=0;     //широта общ в градусах в десятичной мере
  float LONG=0;        //    долгота места в секундах
  float longg=37.0;     //долгота град
  float longm=37.0;     //долгота мин
  float longs=48.0;    //долгота сек
  float KLST=73263.0;
  byte longg1;   // долгота на дисплей градус
  byte longm1;   //долгота на дисплей минуты
  byte longs1;   //долгота на дисплей секунды
  float LAT = 0.0;   //широта общ в радианах
  float ra=0.0;
  float ha=0.0;
  float de=0.0;
  float RA= 0.0;
  float DECr = 0.0;
  float HA = 0.0 ;       // время в радианах
  float A = 0.0; 
  float Aa = 0.0; 
  float ALT1 = 0.0;
  float AZ = 0.0;       //азимут в радианах
  float ALT = 0.0;      //высота альт в радианах
  float ragra=0.0;
  long azshag=0;    //заданное количество шагов по Азимуту AZ
  long altshag=0;  //заданное количество шагов по Высоте Alt
  long rashag=0;  //заданное количество шагов по оси RA
  long decshag=0;  //заданное количество шагов по оси DEC
  long xdan;
  long ydan;
  unsigned long trlimit;  //задержка отображения остальных меню
  unsigned long clicTime;  //задержка клика
  unsigned long tim;
  unsigned long tim1;
  unsigned long timmil;
  unsigned long timmil1;
  int times=1;    //мин задержка шагов 
  int times1=20;   //макс задержка шагов 
  int d=40;  // время сигнала шага
  int pe=20;  //пауза между шагами приускорении для x
  int pe1=20; //пауза между шагами приускорении для y
  byte nx; //определяет направления AZ
  byte ny;//определяет направление ALT
  int tr = 0;
  byte regim=0;
  void setup() {
    // Настраиваем нужные контакты на выход
  pinMode(stepPinx, OUTPUT);      // этот пин даёт команду сделать шаг двигателю1
  pinMode(directionPinx, OUTPUT); // этот пин даёт команду выбрать направление вращения двигателя1
  pinMode(enablePinx, OUTPUT);    // этот пин управляет питанием двигателя1
  pinMode(stepPiny, OUTPUT);        //   шаг   двиг2
  pinMode(directionPiny, OUTPUT);   //   направление  вращения  двиг2
  pinMode(enablePiny, OUTPUT);      //   питание      двиг2
  uView.begin();  // начало работы с MicroView
  // печатаем буквы на дисплее
  uView.clear(PAGE);      // очищаем экран
  uView.setFontType(0);   //шрифт
  uView.setCursor(8, 8);  // перемещаем курсор
  //вывод заставки Б медведица
  uView.print("ALT-AZ 2x"); // печатаем строку
  uView.pixel(8, 31);
  uView.pixel(17, 24);
  uView.pixel(28, 22);
  uView.pixel(38, 26);
  uView.pixel(41, 35);
  uView.pixel(53, 35);
  uView.pixel(55, 26);
  uView.display();  // отображаем содержимое из буфера экрана
  delay(3000);
  uView.clear(PAGE);      // очищаем экран
  delay(500);
  //печатаем буквы
  //главное меню, слежение отключено
  if(tr==0){
  uView.setCursor(0, 0);  // перемещаем курсор
  uView.print("RA"); // печатаем строку
  uView.setCursor(0, 8);  // перемещаем курсор
  uView.print("DEC"); // печатаем строку
  uView.setCursor(0, 16);  // перемещаем курсор
  uView.print("AZ"); // печатаем строку
  uView.setCursor(0, 24);  // перемещаем курсор
  uView.print("ALT"); // печатаем строку
  uView.setCursor(0, 33);  // перемещаем курсор
  uView.print("3B"); // печатаем строку
  uView.setCursor(0, 41);  // перемещаем курсор
  uView.print("MB"); // печатаем строку
  uView.display();  // отображаем содержимое из буфера экрана
  }
  clock.begin();
  // метод установки времени и даты в модуль вручную
  // clock.set(15,58,15,14,12,2019,THURSDAY);
  // метод установки времени и даты автоматически при компиляции
  //clock.set(__TIMESTAMP__);
     }
         // далее идёт цикл программы
  void loop() {
  voltage = analogRead(A0) / 1024.0;   // высчитываем напряжение с кнопок
                   // обучаем контроллер понимать клики кнопок
  // каждая из кнопок при нажатии подаёт напряжение на пин A0 через последовательно соединенные резисторы 
  //напряжение зависит от сопротивления резисторов 
  bool clic1 = (voltage > 0.64 && voltage < 0.68);  // если напряжение находится в пределах от 0.64 до 0.68
  bool clic2 = (voltage > 0.98 && voltage < 1.02);   // аналогично
  bool clic3 = (voltage > 0.69 && voltage < 0.73);   // аналогично
  bool clic4 = (voltage > 0.89 && voltage < 0.93);    // аналогично
  bool clic5 = (voltage > 0.75 && voltage < 0.79);   // аналогично
  bool clic6 = (voltage > 0.81 && voltage < 0.85);
  bool neclic = (voltage < 0.05);
  // если кнопки отпущены - работает стягивающий резистор и на пине "A0" ноль вольт
  // в таком варианте одновременно несколько кнопок работать не могут 
       // если кнопка не нажата,замедляем и останавливаем первый или второй двигатель
      if(neclic&&tr<5) {  
              //для дисплея 
  uView.setCursor(24, 0);  // перемещаем курсор
  uView.print("  "); // печатаем строку
    if(hh<=9){
  uView.setCursor(24, 0);  // перемещаем курсор
  uView.print(0);
  uView.print(hh); // печатаем строку ,часы RA
   }
    else {
  uView.setCursor(24, 0);  // перемещаем курсор
  uView.print(hh); // печатаем строку ,часы RA
    }
  uView.setCursor(46, 0);   // перемещаем курсор 
  uView.print("  ");        // печатаем строку
    if(mm<=9){
  uView.setCursor(46, 0);  // перемещаем курсор
  uView.print(0); // печатаем строку, минуты RA
  uView.print(mm); // печатаем строку, минуты RA
    }
     else{
  uView.setCursor(46, 0);  // перемещаем курсор
  uView.print(mm); // печатаем строку, минуты RA
      }
  uView.setCursor(24, 8);  // перемещаем курсор
  uView.print("   "); // печатаем строку
  uView.setCursor(24, 8);  // перемещаем курсор
  uView.print(decgg); // печатаем строку, градусы DEC
  uView.setCursor(46, 8);  // перемещаем курсор 
  uView.print("   "); // печатаем строку
   if(decmm<=9){
  uView.setCursor(46, 8);  // перемещаем курсор
  uView.print(0); // печатаем строку ,минуты DEC
  uView.print(decmm); // печатаем строку ,минуты DEC
   }
   else{
  uView.setCursor(46, 8);  // перемещаем курсор
  uView.print(decmm); // печатаем строку ,минуты DEC
    }
  uView.setCursor(24, 16);  // перемещаем курсор
  uView.print("   "); // печатаем строку
   if(qg<=9){
  uView.setCursor(24, 16);  // перемещаем курсор
   uView.print(00); // печатаем нули
  uView.print(qg); // печатаем строку,азимут AZ градусы
   }
   if(qg>=10 && qg<=99){
  uView.setCursor(24, 16);  // перемещаем курсор
  uView.print(0); // печатаем нули
  uView.print(qg); // печатаем строку,азимут AZ градусы
    }
   if(qg>=100){
  uView.setCursor(24, 16);  // перемещаем курсор
  uView.print(qg); // печатаем строку,азимут AZ градусы
    }
  uView.setCursor(46, 16);  // перемещаем курсор
  uView.print("   "); // печатаем строку
    if(qm<=9){
  uView.setCursor(46, 16);  // перемещаем курсор
  uView.print(0); // печатаем нули
  uView.print(qm); // печатаем строку, азимут AZ минуты
    }
    else {
  uView.setCursor(46, 16);  // перемещаем курсор
  uView.print(qm); // печатаем строку, азимут AZ минуты
    }
  uView.setCursor(24, 24);  // перемещаем курсор
  uView.print("   "); // печатаем строку
  uView.setCursor(24, 24);  // перемещаем курсор
  uView.print(wg); // печатаем строку,высота ALT градусы
  uView.setCursor(46, 24);  // перемещаем курсор
  uView.print("   "); // печатаем строку
    if(wm<=9){
  uView.setCursor(46, 24);  // перемещаем курсор
  uView.print(0); // печатаем нули
  uView.print(wm); // печатаем строку, высота ALT минуты
    }
    else {
  uView.setCursor(46, 24);  // перемещаем курсор
  uView.print(wm); // печатаем строку, высота ALT минуты
      }
  uView.display();  // отображаем содержимое из буфера экрана

       //создаем текущее время в секундах


   //  uView.setFontType(0);   //шрифт
  uView.setCursor(13, 33);  // перемещаем курсор
  uView.print("       "); // печатаем строку
    if(zh <=9) {
  uView.setCursor(13, 33);  // перемещаем курсор
  uView.print(0); // печатаем ноль
  uView.print(zh); // печатаем строку,звездное время часы
    }
    else{
  uView.setCursor(13, 33);  // перемещаем курсор
  uView.print(zh); // печатаем строку,звездное время часы
      }
  uView.pixel(25, 35);
  uView.pixel(25, 38);
    if(zm<=9) {
  uView.setCursor(27, 33);  // перемещаем курсор
  uView.print(0); // печатаем ноль
  uView.print(zm); // печатаем строку звездное время минуты
    }
    else {
  uView.setCursor(27, 33);  // перемещаем курсор
  uView.print(zm); // печатаем строку звездное время минуты
      }
  uView.pixel(39, 35); // двоеточие
  uView.pixel(39, 38);
    if(zs<=9) {
  uView.setCursor(41, 33);  // перемещаем курсор
  uView.print(0); // печатаем ноль
  uView.print(zs); // печатаем строку звездное время минуты
    }
    else {
  uView.setCursor(41, 33);  // перемещаем курсор
  uView.print(zs); // печатаем строку звездное время минуты
      }
  uView.setCursor(13, 41);  // перемещаем курсор
  uView.print("       "); // печатаем строку
    if(Chas<=9) {
  uView.setCursor(13, 41);  // перемещаем курсор
  uView.print(0); // печатаем ноль
  uView.print(Chas); // печатаем строку,местное время часы
    }
    else {
  uView.setCursor(13, 41);  // перемещаем курсор
  uView.print(Chas); // печатаем строку,местное время часы
      }
  uView.pixel(25, 43);
  uView.pixel(25, 46);
    if(Min<=9) {
  uView.setCursor(27, 41);  // перемещаем курсор
  uView.print(0); // печатаем строку,местное время минуты
  uView.print(Min); // печатаем строку,местное время минуты
    }
    else {
  uView.setCursor(27, 41);  // перемещаем курсор
  uView.print(Min); // печатаем строку,местное время минуты
      }
  uView.pixel(39, 43);
  uView.pixel(39, 46);
    if(SEC<=9) {
  uView.setCursor(41, 41);  // перемещаем курсор
  uView.print(0); // печатаем ноль
  uView.print(SEC); // печатаем строку,местное время минуты
    }
    else {
  uView.setCursor(41, 41);  // перемещаем курсор
  uView.print(SEC); // печатаем строку,местное время минуты
      }    
  uView.display();  // отображаем содержимое из буфера экрана
  }  
              // если кнопка 1 нажата, прибавляем часы (ось RA)
                       // если клик кнопка 1
                 // считываем время, прошедшее с момента запуска программы
      if(clic1 &&tr==0&& millis()>= (clicTime + 130)){          // сравниваем текущий таймер с переменной clicTime2 + 130 мс
  clicTime = millis();  
  h = h + 1 ;                      // при нажатии кнопки прибавляем час  (ось RA)
    if(h >= 24) h = 0;
    decs=0;
    s=0;
  uView.setCursor(24, 0);  // перемещаем курсор
  uView.print("  "); // печатаем строку
   if(hh<=9){
  uView.setCursor(24, 0);  // перемещаем курсор
  uView.print(0); // печатаем ноль
  uView.print(hh); // печатаем строку,часы
   }
   else {
  uView.setCursor(24, 0);  // перемещаем курсор
  uView.print(hh); // печатаем строку,часы
    }
  uView.display();  // отображаем содержимое из буфера экрана
    }
            // если кнопка 2 нажата, прибавляем минуты (ось RA)
    if(clic2 &&tr==0&& millis()>= (clicTime + 130)){      // сравниваем текущий таймер с переменной clicTime2 + 130 мс
  clicTime = millis();                         // считываем время, прошедшее с момента запуска программы  
  m = m + 1;                            // при нажатии кнопки прибавляется 1 минута (ось RA)
    if(m >= 60)  m = 0 ;                  //если минут 60, то обнуляем минуты
  decs=0;
  s=0;
  uView.setCursor(46, 0);             // перемещаем курсор
  uView.print("  ");                 // печатаем строку
    if(mm<=9){
  uView.setCursor(46, 0);             // перемещаем курсор
  uView.print(0);                    // печатаем ноль
  uView.print(mm);                    // печатаем строку,минуты
    }
    else {
  uView.setCursor(46, 0);             // перемещаем курсор
  uView.print(mm);                    // печатаем строку,минуты
      }
  uView.display();                     // отображаем содержимое из буфера экрана
    }
            // если кнопка 3 нажата, прибавляем градусы (ось DEC)
  if(clic3 &&tr==0&& millis() >= (clicTime + 130)){     //проверяем клик сравниваем текущий таймер 
  clicTime = millis();                // считываем время, прошедшее с момента запуска программы
  decg = decg + 1;                        // прибавляем один градус (ось DEC )
  if (decg >= 90) decg = -30;               // если градус больше 90, обнуляем
  decs=0;
  s=0;
  uView.setCursor(24, 8);  // перемещаем курсор
  uView.print("   "); // затираем строку
  uView.setCursor(24, 8);  // перемещаем курсор
  uView.print(decgg); // печатаем строку,градусы
  uView.display();  // отображаем содержимое из буфера экрана
    } 
                // если кнопка 4 нажата,прибавляем минуты DEC в градусах
      if(clic4 &&tr==0&& millis() >= (clicTime + 130)){     // сравниваем текущий таймер с переменной clicTime2 + 130 мс
  clicTime = millis();                         // считываем время, прошедшее с момента запуска программы 
                       // прибавляем минуты (ось DEC)
  if(decg>=0){
  decm = decm + 1;
    if (decm >= 60) decm = 0;          //если минут 60, то обнуляем
  }
  else  if(decg<0){
  decm=decm-1;
  if(decm<=(-60))decm=0;
  }
     decs=0;
    s=0;
  uView.setCursor(46, 8);  // перемещаем курсор
  uView.print("   "); // печатаем строку
   if(decmm<=9) {
  uView.setCursor(46, 8);  // перемещаем курсор
  uView.print(0); // печатаем ноль
  uView.print(decmm); // печатаем строку,минуты
     }
    else {
  uView.setCursor(46, 8);  // перемещаем курсор
  uView.print(decmm); // печатаем строку,минуты
      }
  uView.display();  // отображаем содержимое из буфера экрана
    }
 //вход в меню координат места наблюдения долгота
    if(clic5&&tr<5&&millis()>=(clicTime+300)){
clicTime=millis();
trlimit=millis();
uView.clear(PAGE); 
 tr=5;
  }
//вход в меню координат места наблюдения широта
    if(clic5&&tr==5&&millis()>=(clicTime+300)){
clicTime=millis();
trlimit=millis();
uView.clear(PAGE);
 tr=6;
  }
//вход в меню каталога Месье
   if(clic5&&tr==6&&millis()>=(clicTime+300)){
clicTime=millis();
trlimit=millis();
uView.clear(PAGE); 
 tr=7;
  }
  //вход в меню режима работы
   if(clic5&&tr==7&&millis()>=(clicTime+300)){
clicTime=millis();
trlimit=millis();
uView.clear(PAGE); 
 tr=8;
  }
    //вход в меню корректировка ЗВ времени
   if(clic5&&tr==8&&millis()>=(clicTime+300)){
clicTime=millis();
trlimit=millis();
uView.clear(PAGE); 
 tr=9;
  }
 //******************************************************************************* 
                  // включение выключение слеженияя
      //епсли клик 6
      if(clic6 &&tr<5&& millis() >= (clicTime + 250)){   // сравниваем текущий таймер с переменной loopTime + 1 секунда
  clicTime = millis();  
  tr = tr + 1;           // счетчик нажатий
    if (tr >= 2){
  tr = 0;                          //если tr=0 то слежение останавливается
  digitalWrite(enablePinx,LOW); 
  digitalWrite(stepPinx, LOW);
  digitalWrite(enablePiny,LOW); 
  digitalWrite(stepPiny, LOW);
      uView.setFontType(0);                    //шрифт
  uView.setCursor(53, 41);                    // перемещаем курсор
   uView.print("  ");                          // печатаем "  " стираем "тр" с экрана
  uView.display();                             // отображаем содержимое из буфера экрана
     }
   }
  //**********************************************************************************
if(neclic&&tr>=5&&millis()>=(trlimit+5000)){
tr=0;
  uView.clear(PAGE); 
  uView.setCursor(0, 0);  // перемещаем курсор
  uView.print("RA"); // печатаем строку
  uView.setCursor(0, 8);  // перемещаем курсор
  uView.print("DEC"); // печатаем строку
  uView.setCursor(0, 16);  // перемещаем курсор
  uView.print("AZ"); // печатаем строку
  uView.setCursor(0, 24);  // перемещаем курсор
  uView.print("ALT"); // печатаем строку
  uView.setCursor(0, 33);  // перемещаем курсор
  uView.print("3B"); // печатаем строку
  uView.setCursor(0, 41);  // перемещаем курсор
  uView.print("MB"); // печатаем строку
  uView.setCursor(59, 0);  // перемещаем курсор
  if(regim==0)uView.print("a"); // печатаем строку
  if(regim==1)uView.print("e"); // печатаем строку
  uView.display();  // отображаем содержимое из буфера экрана
}
//меню выбора в каталоге
if(clic2&&tr==5&&millis()>=(clicTime+150)){
 trlimit=millis();
misye+=1;if(misye==111)misye=0;
clicTime=millis();
  }
if(clic4&&tr==5&&millis()>=(clicTime+150)){
  trlimit=millis();
misye-=1;if(misye==(-1))misye=110;
clicTime=millis();
   }
//меню настройки долготы гр мин сек
if(clic2&&tr==6&&millis()>=(clicTime+150)){
 trlimit=millis();
longg+=1;if(longg>=90)longg=0;
clicTime=millis();
  }
if(clic4&&tr==6&&millis()>=(clicTime+150)){
  trlimit=millis();
longm+=1;if(longm>=60)longm=0;
clicTime=millis();
  }
if(clic6&&tr==6&&millis()>=(clicTime+150)){
  trlimit=millis();
longs+=1;if(longs>=60)longs=0;
clicTime=millis();
  }
//меню настройки широты гр мин сек
if(clic2&&tr==7&&millis()>=(clicTime+150)){
 trlimit=millis();
latg+=1;if(latg>=90)latg=0;
clicTime=millis();
  }
if(clic4&&tr==7&&millis()>=(clicTime+150)){
  trlimit=millis();
latm+=1;if(latm>=60)latm=0;
clicTime=millis();
  }
if(clic6&&tr==7&&millis()>=(clicTime+150)){
  trlimit=millis();
lats+=1;if(lats>=60)lats=0;
clicTime=millis();
  }
if(clic2&&tr==8&&millis()>=(clicTime+150)){
  trlimit=millis();
regim+=1;if(regim>=2)regim=0;
clicTime=millis();
  }
if(clic2&&tr==9&&millis()>=(clicTime+150)){
  trlimit=millis();
KLST+=1;
clicTime=millis();
  }
  if(clic4&&tr==9&&millis()>=(clicTime+150)){
  trlimit=millis();
KLST-=1;
clicTime=millis();
  }
  //каталог Месье
      if(tr==5){
if(misye==0){hc=18;mc=37;sc=37;decgc=38;decmc=48;decsc=10;} // star- Vega
if(misye==1){hc=5;mc=35;sc=42;decgc=22;decmc=1;decsc=43;}
if(misye==2){hc=21;mc=34;sc=32;decgc=0;decmc=(-43);decsc=(-39);}
if(misye==3){hc=13;mc=43;sc=7;decgc=28;decmc=17;decsc=1;}
if(misye==4){hc=16;mc=24;sc=49;decgc=(-26);decmc=(-34);decsc=(-42);}
if(misye==5){hc=15;mc=19;sc=37;decgc=2;decmc=0;decsc=42;}
if(misye==6){hc=17;mc=41;sc=24;decgc=(-32);decmc=(-13);decsc=(-33);}
if(misye==7){hc=17;mc=55;sc=14;decgc=(-34);decmc=(-49);decsc=(-9);}
if(misye==8){hc=18;mc=5;sc=1;decgc=(-24);decmc=(-22);decsc=(-52);}
if(misye==9){hc=17;mc=20;sc=22;decgc=(-18);decmc=(-32);decsc=(-10);}
if(misye==10){hc=16;mc=58;sc=9;decgc=(-4);decmc=(-7);decsc=(-47);}
if(misye==11){hc=18;mc=52;sc=10;decgc=(-6);decmc=(-14);decsc=(-31);}
if(misye==12){hc=16;mc=48;sc=14;decgc=(-1);decmc=(-59);decsc=(-4);}
if(misye==13){hc=16;mc=42;sc=25;decgc=36;decmc=25;decsc=47;}
if(misye==14){hc=17;mc=38;sc=39;decgc=(-3);decmc=(-15);decsc=(-38);}
if(misye==15){hc=21;mc=30;sc=58;decgc=12;decmc=15;decsc=17;}
if(misye==16){hc=18;mc=19;sc=56;decgc=(-13);decmc=46;decsc=26;}
if(misye==17){hc=18;mc=21;sc=57;decgc=(-16);decmc=(-10);decsc=(-23);}
if(misye==18){hc=18;mc=21;sc=4;decgc=(-17);decmc=(-7);decsc=(-24);}
if(misye==19){hc=17;mc=3;sc=50;decgc=(-26);decmc=(-17);decsc=(-38);}
if(misye==20){hc=18;mc=3;sc=31;decgc=(-23);decmc=(-1);decsc=(-55);}
if(misye==21){hc=18;mc=5;sc=48;decgc=(-22);decmc=(-29);decsc=(-51);}
if(misye==22){hc=18;mc=37;sc=37;decgc=(-23);decmc=(-52);decsc=56;}
if(misye==23){hc=17;mc=57;sc=59;decgc=(-19);decmc=(-1);decsc=(-5);}
if(misye==24){hc=18;mc=19;sc=34;decgc=(-18);decmc=(-24);decsc=(-27);}
if(misye==25){hc=18;mc=32;sc=47;decgc=(-19);decmc=(-14);decsc=(-4);}
if(misye==26){hc=18;mc=46;sc=18;decgc=(-9);decmc=(-22);decsc=(-41);}
if(misye==27){hc=20;mc=0;sc=28;decgc=22;decmc=46;decsc=20;}
if(misye==28){hc=18;mc=25;sc=44;decgc=(-24);decmc=(-51);decsc=16;}
if(misye==29){hc=20;mc=24;sc=38;decgc=38;decmc=35;decsc=55;}
if(misye==30){hc=21;mc=41;sc=32;decgc=(-23);decmc=(-5);decsc=(-32);}
if(misye==31){hc=0;mc=43;sc=48;decgc=41;decmc=22;decsc=32;}
if(misye==32){hc=0;mc=43;sc=48;decgc=40;decmc=58;decsc=32;}
if(misye==33){hc=1;mc=35;sc=2;decgc=30;decmc=45;decsc=6;}
if(misye==34){hc=2;mc=43;sc=17;decgc=42;decmc=52;decsc=3;}
if(misye==35){hc=6;mc=10;sc=7;decgc=24;decmc=19;decsc=43;}
if(misye==36){hc=5;mc=37;sc=25;decgc=34;decmc=8;decsc=40;}
if(misye==37){hc=5;mc=53;sc=42;decgc=32;decmc=33;decsc=12;}
if(misye==38){hc=5;mc=30;sc=2;decgc=35;decmc=50;decsc=53;}
if(misye==39){hc=21;mc=32;sc=55;decgc=48;decmc=31;decsc=19;}
if(misye==40){hc=12;mc=20;sc=0;decgc=58;decmc=22;decsc=0;}//?
if(misye==41){hc=6;mc=47;sc=51;decgc=(-20);decmc=(-45);decsc=(-22);}
if(misye==42){hc=5;mc=36;sc=23;decgc=(-5);decmc=(-26);decsc=(-18);}
if(misye==43){hc=5;mc=36;sc=35;decgc=(-5);decmc=(-15);decsc=(-18);}
if(misye==44){hc=8;mc=41;sc=15;decgc=19;decmc=54;decsc=43;}
if(misye==45){hc=3;mc=43;sc=54;decgc=23;decmc=58;decsc=0;}//?
if(misye==46){hc=7;mc=42;sc=43;decgc=(-14);decmc=(-5);decsc=(-52);}
if(misye==47){hc=7;mc=37;sc=31;decgc=(-14);decmc=(-32);decsc=(-44);}
if(misye==48){hc=8;mc=14;sc=47;decgc=(-5);decmc=(-51);decsc=(-41);} 
if(misye==49){hc=12;mc=30;sc=49;decgc=7;decmc=53;decsc=25;}
if(misye==50){hc=7;mc=4;sc=10;decgc=(-8);decmc=(-21);decsc=(-49);}
if(misye==51){hc=13;mc=30;sc=50;decgc=47;decmc=9;decsc=52;}
if(misye==52){hc=23;mc=25;sc=6;decgc=61;decmc=41;decsc=34;}
if(misye==53){hc=13;mc=13;sc=53;decgc=18;decmc=3;decsc=41;}
if(misye==54){hc=18;mc=56;sc=23;decgc=(-30);decmc=(-27);decsc=(-24);}
if(misye==55){hc=19;mc=41;sc=16;decgc=(-30);decmc=(-55);decsc=(-10);}
if(misye==56){hc=19;mc=17;sc=23;decgc=30;decmc=13;decsc=12;}
if(misye==57){hc=18;mc=54;sc=21;decgc=33;decmc=3;decsc=33;}
if(misye==58){hc=12;mc=38;sc=42;decgc=11;decmc=42;decsc=27;}
if(misye==59){hc=12;mc=43;sc=0;decgc=11;decmc=32;decsc=28;}
if(misye==60){hc=12;mc=44;sc=42;decgc=11;decmc=26;decsc=28;}
if(misye==61){hc=12;mc=22;sc=55;decgc=4;decmc=21;decsc=23;}
if(misye==62){hc=17;mc=2;sc=28;decgc=(-30);decmc=(-8);decsc=(-40);}
if(misye==63){hc=13;mc=16;sc=42;decgc=41;decmc=55;decsc=43;}
if(misye==64){hc=12;mc=57;sc=41;decgc=21;decmc=34;decsc=33;}
if(misye==65){hc=11;mc=19;sc=56;decgc=12;decmc=58;decsc=27;}
if(misye==66){hc=11;mc=21;sc=14;decgc=12;decmc=52;decsc=27;}
if(misye==67){hc=8;mc=51;sc=29;decgc=11;decmc=44;decsc=29;}
if(misye==68){hc=12;mc=40;sc=34;decgc=(-26);decmc=(-51);decsc=(-33);}
if(misye==69){hc=18;mc=32;sc=42;decgc=(-32);decmc=(-20);decsc=(-4);}
if(misye==70){hc=18;mc=44;sc=30;decgc=(-32);decmc=(-16);decsc=(-44);}
if(misye==71){hc=19;mc=54;sc=41;decgc=18;decmc=50;decsc=11;}
if(misye==72){hc=20;mc=54;sc=36;decgc=(-12);decmc=(-27);decsc=(-25);}
if(misye==73){hc=21;mc=0;sc=6;decgc=(-12);decmc=(-33);decsc=(-18);}
if(misye==74){hc=1;mc=37;sc=46;decgc=15;decmc=53;decsc=4;}
if(misye==75){hc=20;mc=7;sc=16;decgc=(-21);decmc=(-51);decsc=(-31);}
if(misye==76){hc=1;mc=43;sc=34;decgc=51;decmc=39;decsc=59;}
if(misye==77){hc=2;mc=43;sc=43;decgc=0;decmc=4;decsc=2;}
if(misye==78){hc=5;mc=47;sc=43;decgc=0;decmc=3;decsc=22;}
if(misye==79){hc=5;mc=25;sc=19;decgc=(-24);decmc=(-31);decsc=(-59);}
if(misye==80){hc=16;mc=18;sc=11;decgc=(-23);decmc=(-1);decsc=(-52);}
if(misye==81){hc=9;mc=57;sc=13;decgc=68;decmc=58;decsc=18;}
if(misye==82){hc=9;mc=57;sc=26;decgc=69;decmc=35;decsc=18;}
if(misye==83){hc=13;mc=38;sc=8;decgc=(-29);decmc=(-58);decsc=(-3);}
if(misye==84){hc=12;mc=26;sc=7;decgc=12;decmc=46;decsc=24;}
if(misye==85){hc=12;mc=26;sc=24;decgc=18;decmc=4;decsc=24;}
if(misye==86){hc=12;mc=27;sc=13;decgc=12;decmc=50;decsc=24;}
if(misye==87){hc=12;mc=31;sc=49;decgc=12;decmc=17;decsc=25;}
if(misye==88){hc=12;mc=33;sc=0;decgc=14;decmc=18;decsc=25;}
if(misye==89){hc=12;mc=36;sc=42;decgc=12;decmc=26;decsc=26;}
if(misye==90){hc=12;mc=37;sc=48;decgc=13;decmc=3;decsc=27;}
if(misye==91){hc=12;mc=36;sc=24;decgc=14;decmc=23;decsc=26;}
if(misye==92){hc=17;mc=17;sc=43;decgc=43;decmc=6;decsc=46;}
if(misye==93){hc=7;mc=45;sc=27;decgc=(-23);decmc=(-54);decsc=(-56);}
if(misye==94){hc=12;mc=51;sc=50;decgc=41;decmc=0;decsc=31;}
if(misye==95){hc=10;mc=45;sc=3;decgc=11;decmc=35;decsc=43;}
if(misye==96){hc=10;mc=47;sc=51;decgc=11;decmc=42;decsc=41;}
if(misye==97){hc=11;mc=15;sc=57;decgc=54;decmc=54;decsc=29;}
if(misye==98){hc=12;mc=14;sc=49;decgc=14;decmc=47;decsc=22;}
if(misye==99){hc=12;mc=19;sc=49;decgc=14;decmc=18;decsc=23;}
if(misye==100){hc=12;mc=23;sc=55;decgc=15;decmc=42;decsc=24;}
if(misye==101){hc=14;mc=3;sc=54;decgc=54;decmc=15;decsc=18;}
if(misye==102){hc=15;mc=7;sc=3;decgc=55;decmc=41;decsc=27;}
if(misye==103){hc=1;mc=34;sc=32;decgc=60;decmc=48;decsc=6;}
if(misye==104){hc=12;mc=41;sc=2;decgc=(-11);decmc=(-43);decsc=(-32);}
if(misye==105){hc=10;mc=48;sc=51;decgc=12;decmc=28;decsc=41;}
if(misye==106){hc=12;mc=19;sc=59;decgc=47;decmc=11;decsc=23;}
if(misye==107){hc=16;mc=33;sc=37;decgc=(-13);decmc=(-5);decsc=(-28);}
if(misye==108){hc=11;mc=12;sc=39;decgc=55;decmc=33;decsc=30;}
if(misye==109){hc=11;mc=58;sc=38;decgc=53;decmc=16;decsc=21;}
if(misye==110){hc=0;mc=41;sc=30;decgc=41;decmc=47;decsc=32;}
h=hc;
m=mc;
s=sc;
decg=decgc;
decm=decmc;
decs=decsc;
   }
lat=latg+(latm/60)+(lats/3600);    //широта общ в градусах десятичная мера
  //меню каталог Месье
 if(tr==5){
  uView.setCursor(0, 0);  // перемещаем курсор
  uView.print("Catalogue");
  uView.setCursor(0, 8);  // перемещаем курсор
  uView.print("Messier:");
  uView.setCursor(15, 25);  // перемещаем курсор
  uView.print("M-"); // печатаем строку,градусы
    uView.print(misye); // печатаем строку,градусы
  uView.print("  "); // печатаем строку,градусы
  uView.display();  // отображаем содержимое из буфера экрана
  }
//меню широта
if(tr==6){
  longg1=longg;
  longm1=longm;
  longs1=longs;
  uView.setCursor(0, 0);  // перемещаем курсор
  uView.print("longg-"); // печатаем строку,градусы
  uView.setCursor(0,10);  // перемещаем курсор
  uView.print("longm-"); // печатаем строку,градусы
  uView.setCursor(0,20);  // перемещаем курсор
  uView.print("longs-"); // печатаем строку,градусы
  uView.setCursor(45, 0);  // перемещаем курсор
  uView.print(longg1); // печатаем строку,градусы
  uView.print(" ");
  uView.setCursor(45,10);  // перемещаем курсор
  uView.print(longm1); // печатаем строку,градусы
  uView.print(" ");
  uView.setCursor(45,20);  // перемещаем курсор
  uView.print(longs1); // печатаем строку,градусы
  uView.print(" ");
  uView.display();  // отображаем содержимое из буфера экрана
    }
//меню долгота
if(tr==7){
  latg1=latg;
  latm1=latm;
  lats1=lats;
  uView.setCursor(0, 0);  // перемещаем курсор
  uView.print("latg-"); // печатаем строку,градусы
  uView.setCursor(0,10);  // перемещаем курсор
  uView.print("latm-"); // печатаем строку,градусы
  uView.setCursor(0,20);  // перемещаем курсор
  uView.print("lats-"); // печатаем строку,градусы
  uView.setCursor(45, 0);  // перемещаем курсор
  uView.print(latg1); // печатаем строку,градусы
  uView.print(" ");
  uView.setCursor(45,10);  // перемещаем курсор
  uView.print(latm1); // печатаем строку,градусы
  uView.print(" ");
  uView.setCursor(45,20);  // перемещаем курсор
  uView.print(lats1); // печатаем строку,градусы
  uView.print(" ");
  uView.display();  // отображаем содержимое из буфера экрана
   }
if(tr==8){
  uView.setCursor(0, 0);  // перемещаем курсор
  uView.print("regim-"); // печатаем строку режим
  uView.setCursor(45, 0);  // перемещаем курсор
  uView.print(regim); // печатаем строку,regim
  uView.display();  // отображаем содержимое из буфера экрана
  }
  if(tr==9){
  uView.setCursor(0, 0);  // перемещаем курсор
  uView.print("KLST"); // KLST корректировочный коэффициент
  uView.setCursor(0, 10);  // перемещаем курсор
  uView.print(KLST); // KLST корректировочный коэффициент
 //вывод Звездного времени 
  uView.setCursor(13, 33);  // перемещаем курсор
  uView.print("       "); // печатаем строку
    if(zh <=9) {
  uView.setCursor(13, 33);  // перемещаем курсор
  uView.print(0); // печатаем ноль
  uView.print(zh); // печатаем строку,звездное время часы
    }
    else{
  uView.setCursor(13, 33);  // перемещаем курсор
  uView.print(zh); // печатаем строку,звездное время часы
      }
  uView.pixel(25, 35);
  uView.pixel(25, 38);
    if(zm<=9) {
  uView.setCursor(27, 33);  // перемещаем курсор
  uView.print(0); // печатаем ноль
  uView.print(zm); // печатаем строку звездное время минуты
    }
    else {
  uView.setCursor(27, 33);  // перемещаем курсор
  uView.print(zm); // печатаем строку звездное время минуты
      }
  uView.pixel(39, 35); // двоеточие
  uView.pixel(39, 38);
    if(zs<=9) {
  uView.setCursor(41, 33);  // перемещаем курсор
  uView.print(0); // печатаем ноль
  uView.print(zs); // печатаем строку звездное время минуты
    }
    else {
  uView.setCursor(41, 33);  // перемещаем курсор
  uView.print(zs); // печатаем строку звездное время минуты
    }
  uView.display();  // отображаем содержимое из буфера экрана
  }
  //*************************************************************************************************
  //*************************************************************************************************
   //режим наведения az alt
     if(regim==0&&tr==1){
   if(q!=azshag||w!=altshag){
 uView.setCursor(53, 33);  // перемещаем курсор
  uView.print("Go"); // печатаем строку,градусы
  uView.display();  // отображаем содержимое из буфера экрана
   }
 p=1;
tim=millis();
tim1=millis();
while(q!=azshag||w!=altshag){
if(q!=azshag){
if(millis()>=(tim+pe)){
if(q<azshag){xdan=azshag-q;q+=1;nx=1;}//записываем шаг и выбираем направление nx
if(q>azshag){xdan=q-azshag;q-=1;nx=0;}//записываем шаг и выбираем направление nx
digitalWrite(enablePinx, p);  // питание          
digitalWrite(directionPinx, nx); // направление
digitalWrite(stepPinx, HIGH);    // шаг
//delayMicroseconds(d);//пауза,чтобы двигатель успел откликнуться и шагнуть, иначе бывают пропуски
digitalWrite(stepPinx, LOW);   // не шаг
tim=millis();
}
 if(millis()>=(timmil+50)){
if(xdan>400){pe-=1;if(pe<=times)pe=times;} //если шагать много,то ускоряем,уменьшая паузу pe
if(xdan<400){pe+=1;if(pe>=times1)pe=times1;}//если осталось шагать мало,то замедляем,увиличивая паузу pe
timmil=millis();
}
}
if(w!=altshag){
if(millis()>=(tim1+pe1)){
  if(w<altshag){ydan=altshag-w;w+=1;ny=1;}//записываем шаг и выбираем направление ny
  if(w>altshag){ydan=w-altshag;w-=1;ny=0;}//записываем шаг и выбираем направление ny
digitalWrite(enablePiny, p);  // питание          
digitalWrite(directionPiny, ny); // направление
digitalWrite(stepPiny, HIGH);    // шаг
//delayMicroseconds(d);//пауза,чтобы двигатель успел откликнуться и шагнуть, иначе бывают пропуски
digitalWrite(stepPiny, LOW);   // не шаг
tim1=millis();
}
 if(millis()>=(timmil1+50)){
if(ydan>400){pe1-=1;if(pe1<=times)pe1=times;}//если шагать много,то ускоряем,уменьшая паузу pe1
if(ydan<400){pe1+=1;if(pe1>=times1)pe1=times1;}//если осталось шагать мало,то замедляем,увиличивая паузу pe1
timmil1=millis();
}
}
}
if(q==azshag||w==altshag){
 uView.setCursor(53, 33);  // перемещаем курсор
 uView.print("  "); // печатаем строку,градусы
 uView.display();  // отображаем содержимое из буфера экрана
  }
 }
   //режим наведения EQ
     if(regim==1&&tr==1){
   if(q!=rashag||w!=decshag){
 uView.setCursor(53, 33);  // перемещаем курсор
  uView.print("Go"); // печатаем строку,градусы
  uView.display();  // отображаем содержимое из буфера экрана
   }
 p=1;
tim=millis();
tim1=millis();
while(q!=rashag||w!=decshag){
if(q!=rashag){
if(millis()>=(tim+pe)){
if(q<rashag){xdan=rashag-q;q+=1;nx=1;}//записываем шаг и выбираем направление nx
if(q>rashag){xdan=q-rashag;q-=1;nx=0;}//записываем шаг и выбираем направление nx
digitalWrite(enablePinx, p);  // питание          
digitalWrite(directionPinx, nx); // направление
digitalWrite(stepPinx, HIGH);    // шаг
//delayMicroseconds(d);//пауза,чтобы двигатель успел откликнуться и шагнуть, иначе бывают пропуски
digitalWrite(stepPinx, LOW);   // не шаг
tim=millis();
}
 if(millis()>=(timmil+50)){
if(xdan>400){pe-=1;if(pe<=times)pe=times;} //если шагать много,то ускоряем,уменьшая паузу pe
if(xdan<400){pe+=1;if(pe>=times1)pe=times1;}//если осталось шагать мало,то замедляем,увиличивая паузу pe
timmil=millis();
}
}
if(w!=decshag){
if(millis()>=(tim1+pe1)){
  if(w<decshag){ydan=decshag-w;w+=1;ny=1;}//записываем шаг и выбираем направление ny
  if(w>decshag){ydan=w-decshag;w-=1;ny=0;}//записываем шаг и выбираем направление ny
digitalWrite(enablePiny, p);  // питание          
digitalWrite(directionPiny, ny); // направление
digitalWrite(stepPiny, HIGH);    // шаг
//delayMicroseconds(d);//пауза,чтобы двигатель успел откликнуться и шагнуть, иначе бывают пропуски
digitalWrite(stepPiny, LOW);   // не шаг
tim1=millis();
}
 if(millis()>=(timmil1+50)){
if(ydan>400){pe1-=1;if(pe1<=times)pe1=times;}//если шагать много,то ускоряем,уменьшая паузу pe1
if(ydan<400){pe1+=1;if(pe1>=times1)pe1=times1;}//если осталось шагать мало,то замедляем,увиличивая паузу pe1
timmil1=millis();
}
}
}
if(q==rashag||w==decshag){
 uView.setCursor(53, 33);  // перемещаем курсор
 uView.print("  "); // печатаем строку,градусы
 uView.display();  // отображаем содержимое из буфера экрана
  }
 }
   // режим слежения
       if(tr==1){
  // т
  uView.line(57,42,60,42);
  uView.line(58,43,58,46);
  // р
  uView.line(61,42,61,46);
  uView.pixel(62, 42);
  uView.pixel(62, 44);
  uView.pixel(63, 43);
  uView.display();  // отображаем содержимое из буфера экрана 
   }
 /////////////////  
           // расчет звездного времени
clock.read();            // запрашиваем данные с модуля часов
god=clock.getYear();      // год
mes=clock.getMonth();     // месяц
ciclo= clock.getDay();     // число месяца
Chas= clock.getHour();     // часы из модуля часов
Min= clock.getMinute();    // минуты
SEC = clock.getSecond();   // секунды
// if(god==2017)  dney=0.0;
// if(god==2018) dney=365;
 //if(god==2019)dney=730;
 //if(god==2020)dney=1096;//високосный
 if(god==2021)dney=1461;
 if(god==2022)dney=1826;
 if(god==2023)dney=2191;
 if(god==2024)dney=2557;//високосный
 if(god==2025)dney=2922;
 if(god==2026)dney=3287;
 if(god==2027)dney=3652;
 if(god==2028)dney=4018;//високосный
 if(god==2029)dney=4383;
 if(god==2030)dney=4748;
    if(mes==1) den=0;
    if(mes==2) den=31;
    if(mes==3) den=59;
    if(mes==4) den=90;
    if(mes==5) den=120;
    if(mes==6) den=151;
    if(mes==7) den=181;
    if(mes==8) den=212;
    if(mes==9) den=243;
    if(mes==10) den=273;
    if(mes==11) den=304;
    if(mes==12) den=334;
///////////////////////////////////////////////////////////////////
       // формулы
LONG=((longg*3600)+(longm*60)+longs)/15;
kden=(dney+den+ciclo)*236.555; // общ количество секунд накопившихся с начала 2017 года
kvrem=((Chas*3600)+(Min*60)+SEC)*1.002739;
lsts=kvrem+kden+LONG-KLST;  // корректировка ЗВ времени 73282
lsth=lsts/3600;
if(lsth>=24){
for(int i=lsth;i>=24;i-=24){
lsth=lsth-24;
}}
zh=lsth;
zm1=(lsth-zh)*60;
zm=zm1;
zs1=(zm1-zm)*60;
zs=zs1;
lst=lsth*15;  //часы в градусы превращаю
    ////////////////////////////////////////////////////////////////////
          // восьмибитный процессор ведет расчет не достаточно точно но более менее нормально
  ras = ((h)*3600)+ ((m)*60)+(s); // прямое восхождение в секундах
  ra = (ras/3600)*15;     // прямое восхождение в градусах, в десятичной мере
  ha = lst - ra;          // часовой угол в градусах
  de = decg + (decm/60)+(decs/3600);  // склонение в градусах,десятичная мера
  LAT = (lat*PI)/180;   // переводим широту в радианы 
  DECr = (de*PI)/180;   // переводим склонение в радианы
  HA = ((ha*PI)/180);     // переводим часовой угол в радианы
               // пересчитываем RA DEC в ALT и AZ по формулам
/////////////////////////
     //  пришлось блин тригонометрию сидеть учить
 ALT1 = sin(DECr)*sin(LAT)+cos(DECr)*cos(LAT)*cos(HA);
 ALT = asin(ALT1);
 Aa = (sin(DECr) - sin(ALT)*sin(LAT))/ (cos(ALT)*cos(LAT));
 A = acos(Aa);
    if (sin(HA)< 0) AZ = A;     
  else{
  AZ = 6.28318530718 - A;
    }
///////////////////////////       
  hh=h;         //float превращаю в int то есть округляю
  mm=m;
  if(mm<0)mm=mm/(-1);
  decgg=decg;
  decmm=decm;
  if(decmm<0)decmm=decmm/(-1);
  q1 = (AZ*180)/PI;  // превращаем азимут в градусную меру 
  w1 = (ALT*180)/PI; // высота в градусах  
  azshag=q1* 200;     // азимут в шагах,тут можно менять передаточное число привода меняя число в этой формуле
  altshag=w1* 200;    // высота в шагах,тут можно менять передаточное число привода меняя число в этой формуле
                       // q1x240=360*240=86400 шагов
  //EQ режим
  ragra= ra + lst;
  while(ragra>=360){ragra-=360;}
   rashag =ragra * 200; //ось RA заданное количество шагов
  decshag = de * 200; //ось DEC заданное количество шагов
         // это для работы с экраном
qg=q1; qm=(q1-qg)*60; qflm=(q1-qg)*60; qs=(qflm-qm)*60;
wg=w1; wm=(w1-wg)*60;if(wm<0)wm=wm/(-1); wflm=wm; ws=(wflm-wm)*60;
   }   
